﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.IO;
using System.Reflection;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

public partial class _Default : BasePage
{
    #region Constants
    // Holds the name of the contrl to load dynamically
    private const string MYCONTROL = "MyControl.ascx";
    // Holds the format of the UserControl's ClientID
    private const string MYCONTROL_ID = "MyControl_{0}";
    #endregion

    #region Page Events
    protected void Page_Init(object sender, EventArgs e)
    {
        // ALWAYS Load existing controls
        LoadExistingControls(this.phContainer);
        LoadExistingControls(this.phContainer1);
    }
    #endregion

    #region Commented out
    //#region Reflection Helper Methods
    ///// <summary>
    ///// Returns the type of the control to load
    ///// </summary>
    ///// <param name="nameOfControl"></param>
    ///// <returns></returns>
    //private Type GetControlTypeByName(string nameOfControl)
    //{
    //    // Validate the name of the control that we want
    //    // to locate
    //    if (string.IsNullOrEmpty(nameOfControl))
    //        return null;

    //    // Find the assembly of the control 
    //    FindControlsAssembly(nameOfControl);

    //    if (Cache[string.Format(TYPE_CACHE_KEY, nameOfControl)] != null)
    //        return (Type)Cache[string.Format(TYPE_CACHE_KEY, nameOfControl)];

    //    return null;
    //}

    ///// <summary>
    ///// Finds the assembly that contains the control
    ///// we are after
    ///// </summary>
    ///// <param name="nameOfType"></param>
    //private void FindControlsAssembly(string nameOfType)
    //{
    //    string typeNameInCache = string.Format(TYPE_CACHE_KEY, nameOfType);

    //    if (Cache[typeNameInCache] != null)
    //        return;

    //    // Loop through all the assembly executing
    //    // and find the type that belongs to the assembly
    //    foreach (Assembly a in AppDomain.CurrentDomain.GetAssemblies())
    //    {
    //        Type t = a.GetType(nameOfType);
    //        if (t != null)
    //        {
    //            // Store the type in the cache
    //            Cache[typeNameInCache] = t;
    //            break;
    //        }
    //    }
    //}
    //#endregion
    #endregion

    /// <summary>
    /// Initializes a new UserControl and adds it to a container
    /// on the page.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnAddNew_Click(object sender, EventArgs e)
    {
        // Create a new control instance
        UserControl c = CreateControlInstance(
            MYCONTROL,
            MYCONTROL_ID);

        // Add the new control to the phContainer place holder
        AddControlToContainer(c, this.phContainer);

        // Load again the already added controls
        // to the specified container.
        LoadExistingControls(this.phContainer);
    }
    
    /// <summary>
    /// Process the values inside each loaded UserControl
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnSave_Click(object sender, EventArgs e)
    {
        // If there are controls loaded inside the phContainer place holder
        // Every container is accessed by its ClientID
        if (
            (this.Container[this.phContainer.ClientID] != null) &&
            (this.Container[this.phContainer.ClientID].Count > 0)
            )
        {
            // Loop through all the KeyValuePairs that constitute
            // the elements of the specific container
            foreach (KeyValuePair<string, UserControl> value in this.Container[this.phContainer.ClientID])
            {
                // Case the value.Value which is a UserControl
                // into the Interface so that you can access
                // the Save method implementation on the UserControl
                ((IMyControls)value.Value).Save();
            }
        }
    }
    protected void btnSave1_Click(object sender, EventArgs e)
    {
        if (
            (this.Container[this.phContainer1.ClientID] != null) &&
            (this.Container[this.phContainer1.ClientID].Count > 0)
            )
        {
            foreach (KeyValuePair<string, UserControl> value in this.Container[this.phContainer1.ClientID])
            {
                ((IMyControls)value.Value).Save();
            }
        }
    }
    protected void btnNew1_Click(object sender, EventArgs e)
    {
        // Create a new control instance
        UserControl c = CreateControlInstance(
            MYCONTROL,
            MYCONTROL_ID);

        // Add the new control to the container
        AddControlToContainer(c, this.phContainer1);

        // Load again the controls
        LoadExistingControls(this.phContainer1);
    }
}